﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using PT.ERPTransmissions;
using PT.Scheduler;
using PT.Scheduler.Simulation.Customizations;
using PT.Transmissions;

namespace PlanetTogether.Sample.ActionAfterImport
{
    public class PostImportOptimize : PT.Scheduler.Simulation.Customizations.EndOfSimulationCustomization
    {
        public override string Name => "Optimize After Import";
        public override string Description => "Send an optimize after import is complete";

        protected override void SimulationInitialization(ScenarioDetail a_sd, ScenarioDetail.SimulationType a_simulationType, ScenarioBaseT a_transmission)
        {
            CleanTransmissionsProcess();
        }

        protected override void EndOfSimulationCleanup(ScenarioDetail.SimulationType a_simType, ScenarioBaseT a_t, ScenarioDetail a_sd)
        {
            //Checks if the ScenarioBaseT is an Import transmission 
            if (a_t is ImportT)
            {
                // Creates a new Optimize transmission that uses the ScenarioDetail ID, uses the Scenario Optimize option, ut does not run MRP.
                ScenarioDetailOptimizeT optimizeT = new ScenarioDetailOptimizeT(a_sd.Scenario.Id, true, false);
                AddTransmissionsToProcess(0, optimizeT);
            }

            //Example on how to check imported data to determine if an action should be taken
            //if (a_t is ImportT importT)
            //{
            //    for (var i = 0; i < importT.Count; i++)
            //    {
            //        ERPTransmission erpTransmission = importT[i];
            //        if (erpTransmission is JobT jobT)
            //        {
            //            if (jobT.Count > 0)
            //            {
            //                ScenarioDetailOptimizeT optimizeT = new ScenarioDetailOptimizeT(a_sd.Scenario.Id, true, false);
            //                AddTransmissionsToProcess(0, optimizeT);
            //            }
            //        }
            //    }
            //}

        }
    }
}
